require "verse"
require "verse.XEP0060"

local xep = { xmlns = 'http://www.w3.org/2005/Atom' };
verse.protocols.atompub = xep;

xep.events = {
  response = 	{
  			{ "XEP0060", "response" }; -- This event is a post-processor of XEP-0060 responses
			atom_source_title = "/iq/*/*/item/entry/source/title/text()";
			atom_source_link = "/iq/*/*/item/entry/source/link/text()";
			atom_source_id = "/iq/*/*/item/entry/source/id/text()";
			atom_source_updated = "/iq/*/*/item/entry/source/updated/text()";
			atom_author_name = "/iq/*/*/item/entry/source/author/name/text()";
			
			atom_title = "/iq/*/*/item/entry/title/text()";
			atom_link = "/iq/*/*/item/entry/link/text()";
			atom_id = "/iq/*/*/item/entry/id/text()";
			atom_published = "/iq/*/*/item/entry/published/text()";
			atom_updated = "/iq/*/*/item/entry/updated/text()";
		};
}

function xep.request_last(request)
	return verse.iq{ to = request.to, type = "get", id = verse.new_id() }
		:tag("query", { xmlns = verse.XEP0060.xmlns })
			:tag("items", { node = xep.xmlns, max_items = request.max_items or 1});
end

function xep.publish(tune)
	return verse.iq{to = tune.to, type = "set", id = verse.new_id() }
			:tag("query", { xmlns = verse.XEP0060.xmlns })
				:tag("publish", { node = xep.xmlns })
					:tag("item")
						:tag("tune", { xmlns = xep.xmlns })
							:tag("artist"):text(tune.artist or "Unknown Artist"):up()
							:tag("title"):text(tune.title or "Untitled");
end
